#ifndef _VGA_H
#define _VGA_H 1

#include <restrict.h>
#include <kernel/io.h>
#include <kernel/os.h>
#include <stddef.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>

#define vga_char(c, attrib) \
    ((int16_t) c | ((((int16_t) attrib) << 8) & 0xFF00))

void vga_init     (void);
void vga_set      (unsigned short *video, int columns,
                   int rows, int x, int y, int position,
                   int attribute);
int  vga_clear    (void);
void vga_new_line (void);
void vga_putc     (int c);
void vga_puts     (char *string, size_t n);
int  vga_vprintf  (const char *restrict format,
                   va_list arg);
int  vga_printf   (const char *restrict format, ...);

#define clear()   (vga_clear ())
#define echo()    (os.kbd.echo = 1)
#define noecho()  (os.kbd.echo = 0)

#endif
